// generated by diplomat-tool

// https://github.com/dart-lang/sdk/issues/53946
// ignore_for_file: non_native_function_type_argument_to_pointer

part of 'lib.g.dart';

/// Bidi information for a single processed paragraph
final class BidiParagraph implements ffi.Finalizable {
  final ffi.Pointer<ffi.Opaque> _underlying;

  final core.List<Object> _edge_self;
  final core.List<Object> _edge_info;

  // Internal constructor from FFI.
  // isOwned is whether this is owned (has finalizer) or not
  // This also takes in a list of lifetime edges (including for &self borrows)
  // corresponding to data this may borrow from. These should be flat arrays containing
  // references to objects, and this object will hold on to them to keep them alive and
  // maintain borrow validity.
  BidiParagraph._(this._underlying, bool isOwned, this._edge_self, this._edge_info) {
    if (isOwned) {
      _finalizer.attach(this, _underlying.cast());
    }
  }

  static final _finalizer = ffi.NativeFinalizer(ffi.Native.addressOf(_ICU4XBidiParagraph_destroy));

  /// Given a paragraph index `n` within the surrounding text, this sets this
  /// object to the paragraph at that index. Returns `Error::OutOfBoundsError` when out of bounds.
  ///
  /// This is equivalent to calling `paragraph_at()` on `BidiInfo` but doesn't
  /// create a new object
  ///
  /// Throws [Error] on failure.
  void setParagraphInText(int n) {
    final result = _ICU4XBidiParagraph_set_paragraph_in_text(_underlying, n);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// The primary direction of this paragraph
  ///
  /// See the [Rust documentation for `level_at`](https://docs.rs/unicode_bidi/latest/unicode_bidi/struct.Paragraph.html#method.level_at) for more information.
  BidiDirection get direction {
    final result = _ICU4XBidiParagraph_direction(_underlying);
    return BidiDirection.values[result];
  }

  /// The number of bytes in this paragraph
  ///
  /// See the [Rust documentation for `len`](https://docs.rs/unicode_bidi/latest/unicode_bidi/struct.ParagraphInfo.html#method.len) for more information.
  int get size {
    final result = _ICU4XBidiParagraph_size(_underlying);
    return result;
  }

  /// The start index of this paragraph within the source text
  int get rangeStart {
    final result = _ICU4XBidiParagraph_range_start(_underlying);
    return result;
  }

  /// The end index of this paragraph within the source text
  int get rangeEnd {
    final result = _ICU4XBidiParagraph_range_end(_underlying);
    return result;
  }

  /// Reorder a line based on display order. The ranges are specified relative to the source text and must be contained
  /// within this paragraph's range.
  ///
  /// See the [Rust documentation for `level_at`](https://docs.rs/unicode_bidi/latest/unicode_bidi/struct.Paragraph.html#method.level_at) for more information.
  ///
  /// Throws [Error] on failure.
  String reorderLine(int rangeStart, int rangeEnd) {
    final writeable = _Writeable();
    final result = _ICU4XBidiParagraph_reorder_line(_underlying, rangeStart, rangeEnd, writeable._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    return writeable.finalize();
  }

  /// Get the BIDI level at a particular byte index in this paragraph.
  /// This integer is conceptually a `unicode_bidi::Level`,
  /// and can be further inspected using the static methods on ICU4XBidi.
  ///
  /// Returns 0 (equivalent to `Level::ltr()`) on error
  ///
  /// See the [Rust documentation for `level_at`](https://docs.rs/unicode_bidi/latest/unicode_bidi/struct.Paragraph.html#method.level_at) for more information.
  int levelAt(int pos) {
    final result = _ICU4XBidiParagraph_level_at(_underlying, pos);
    return result;
  }
}

@meta.ResourceIdentifier()
@ffi.Native<ffi.Void Function(ffi.Pointer<ffi.Void>)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_destroy')
// ignore: non_constant_identifier_names
external void _ICU4XBidiParagraph_destroy(ffi.Pointer<ffi.Void> self);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Size)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_set_paragraph_in_text')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XBidiParagraph_set_paragraph_in_text(ffi.Pointer<ffi.Opaque> self, int n);

@meta.ResourceIdentifier()
@ffi.Native<ffi.Int32 Function(ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_direction')
// ignore: non_constant_identifier_names
external int _ICU4XBidiParagraph_direction(ffi.Pointer<ffi.Opaque> self);

@meta.ResourceIdentifier()
@ffi.Native<ffi.Size Function(ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_size')
// ignore: non_constant_identifier_names
external int _ICU4XBidiParagraph_size(ffi.Pointer<ffi.Opaque> self);

@meta.ResourceIdentifier()
@ffi.Native<ffi.Size Function(ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_range_start')
// ignore: non_constant_identifier_names
external int _ICU4XBidiParagraph_range_start(ffi.Pointer<ffi.Opaque> self);

@meta.ResourceIdentifier()
@ffi.Native<ffi.Size Function(ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_range_end')
// ignore: non_constant_identifier_names
external int _ICU4XBidiParagraph_range_end(ffi.Pointer<ffi.Opaque> self);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Size, ffi.Size, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_reorder_line')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XBidiParagraph_reorder_line(ffi.Pointer<ffi.Opaque> self, int rangeStart, int rangeEnd, ffi.Pointer<ffi.Opaque> writeable);

@meta.ResourceIdentifier()
@ffi.Native<ffi.Uint8 Function(ffi.Pointer<ffi.Opaque>, ffi.Size)>(isLeaf: true, symbol: 'ICU4XBidiParagraph_level_at')
// ignore: non_constant_identifier_names
external int _ICU4XBidiParagraph_level_at(ffi.Pointer<ffi.Opaque> self, int pos);
