// generated by diplomat-tool

// https://github.com/dart-lang/sdk/issues/53946
// ignore_for_file: non_native_function_type_argument_to_pointer

part of 'lib.g.dart';

final class _CodePointRangeIteratorResultFfi extends ffi.Struct {
  @ffi.Uint32()
  external int start;
  @ffi.Uint32()
  external int end;
  @ffi.Bool()
  external bool done;
}

/// Result of a single iteration of [`CodePointRangeIterator`].
/// Logically can be considered to be an `Option<RangeInclusive<u32>>`,
///
/// `start` and `end` represent an inclusive range of code points [start, end],
/// and `done` will be true if the iterator has already finished. The last contentful
/// iteration will NOT produce a range done=true, in other words `start` and `end` are useful
/// values if and only if `done=false`.
final class CodePointRangeIteratorResult {
  final int start;
  final int end;
  final bool done;

  // ignore: unused_element
  // Internal constructor from FFI.
  // This struct contains borrowed fields, so this takes in a list of
  // "edges" corresponding to where each lifetime's data may have been borrowed from
  // and passes it down to individual fields containing the borrow.
  // This method does not attempt to handle any dependencies between lifetimes, the caller
  // should handle this when constructing edge arrays.
  CodePointRangeIteratorResult._(_CodePointRangeIteratorResultFfi underlying) :
    start = underlying.start,
    end = underlying.end,
    done = underlying.done;

  // ignore: unused_element
  _CodePointRangeIteratorResultFfi _pointer(ffi.Allocator temp) {
    final pointer = temp<_CodePointRangeIteratorResultFfi>();
    pointer.ref.start = start;
    pointer.ref.end = end;
    pointer.ref.done = done;
    return pointer.ref;
  }

  @override
  bool operator ==(Object other) =>
      other is CodePointRangeIteratorResult &&
      other.start == this.start &&
      other.end == this.end &&
      other.done == this.done;

  @override
  int get hashCode => Object.hashAll([
        this.start,
        this.end,
        this.done,
      ]);
}
