// generated by diplomat-tool

// https://github.com/dart-lang/sdk/issues/53946
// ignore_for_file: non_native_function_type_argument_to_pointer

part of 'lib.g.dart';

/// See the [Rust documentation for `PluralRules`](https://docs.rs/icu/latest/icu/plurals/struct.PluralRules.html) for more information.
final class PluralRules implements ffi.Finalizable {
  final ffi.Pointer<ffi.Opaque> _underlying;

  final core.List<Object> _edge_self;

  // Internal constructor from FFI.
  // isOwned is whether this is owned (has finalizer) or not
  // This also takes in a list of lifetime edges (including for &self borrows)
  // corresponding to data this may borrow from. These should be flat arrays containing
  // references to objects, and this object will hold on to them to keep them alive and
  // maintain borrow validity.
  PluralRules._(this._underlying, bool isOwned, this._edge_self) {
    if (isOwned) {
      _finalizer.attach(this, _underlying.cast());
    }
  }

  static final _finalizer = ffi.NativeFinalizer(ffi.Native.addressOf(_ICU4XPluralRules_destroy));

  /// Construct an [`PluralRules`] for the given locale, for cardinal numbers
  ///
  /// See the [Rust documentation for `try_new_cardinal`](https://docs.rs/icu/latest/icu/plurals/struct.PluralRules.html#method.try_new_cardinal) for more information.
  ///
  /// Throws [Error] on failure.
  factory PluralRules.cardinal(DataProvider provider, Locale locale) {
    final result = _ICU4XPluralRules_create_cardinal(provider._underlying, locale._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    return PluralRules._(result.union.ok, true, []);
  }

  /// Construct an [`PluralRules`] for the given locale, for ordinal numbers
  ///
  /// See the [Rust documentation for `try_new_ordinal`](https://docs.rs/icu/latest/icu/plurals/struct.PluralRules.html#method.try_new_ordinal) for more information.
  ///
  /// Throws [Error] on failure.
  factory PluralRules.ordinal(DataProvider provider, Locale locale) {
    final result = _ICU4XPluralRules_create_ordinal(provider._underlying, locale._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    return PluralRules._(result.union.ok, true, []);
  }

  /// Get the category for a given number represented as operands
  ///
  /// See the [Rust documentation for `category_for`](https://docs.rs/icu/latest/icu/plurals/struct.PluralRules.html#method.category_for) for more information.
  PluralCategory categoryFor(PluralOperands op) {
    final result = _ICU4XPluralRules_category_for(_underlying, op._underlying);
    return PluralCategory.values[result];
  }

  /// Get all of the categories needed in the current locale
  ///
  /// See the [Rust documentation for `categories`](https://docs.rs/icu/latest/icu/plurals/struct.PluralRules.html#method.categories) for more information.
  PluralCategories get categories {
    final result = _ICU4XPluralRules_categories(_underlying);
    return PluralCategories._(result);
  }
}

@meta.ResourceIdentifier()
@ffi.Native<ffi.Void Function(ffi.Pointer<ffi.Void>)>(isLeaf: true, symbol: 'ICU4XPluralRules_destroy')
// ignore: non_constant_identifier_names
external void _ICU4XPluralRules_destroy(ffi.Pointer<ffi.Void> self);

@meta.ResourceIdentifier()
@ffi.Native<_ResultOpaqueInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XPluralRules_create_cardinal')
// ignore: non_constant_identifier_names
external _ResultOpaqueInt32 _ICU4XPluralRules_create_cardinal(ffi.Pointer<ffi.Opaque> provider, ffi.Pointer<ffi.Opaque> locale);

@meta.ResourceIdentifier()
@ffi.Native<_ResultOpaqueInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XPluralRules_create_ordinal')
// ignore: non_constant_identifier_names
external _ResultOpaqueInt32 _ICU4XPluralRules_create_ordinal(ffi.Pointer<ffi.Opaque> provider, ffi.Pointer<ffi.Opaque> locale);

@meta.ResourceIdentifier()
@ffi.Native<ffi.Int32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XPluralRules_category_for')
// ignore: non_constant_identifier_names
external int _ICU4XPluralRules_category_for(ffi.Pointer<ffi.Opaque> self, ffi.Pointer<ffi.Opaque> op);

@meta.ResourceIdentifier()
@ffi.Native<_PluralCategoriesFfi Function(ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XPluralRules_categories')
// ignore: non_constant_identifier_names
external _PluralCategoriesFfi _ICU4XPluralRules_categories(ffi.Pointer<ffi.Opaque> self);
