// generated by diplomat-tool

// https://github.com/dart-lang/sdk/issues/53946
// ignore_for_file: non_native_function_type_argument_to_pointer

part of 'lib.g.dart';

/// An ICU4X TimeZoneFormatter object capable of formatting an [`CustomTimeZone`] type (and others) as a string
///
/// See the [Rust documentation for `TimeZoneFormatter`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html) for more information.
final class TimeZoneFormatter implements ffi.Finalizable {
  final ffi.Pointer<ffi.Opaque> _underlying;

  final core.List<Object> _edge_self;

  // Internal constructor from FFI.
  // isOwned is whether this is owned (has finalizer) or not
  // This also takes in a list of lifetime edges (including for &self borrows)
  // corresponding to data this may borrow from. These should be flat arrays containing
  // references to objects, and this object will hold on to them to keep them alive and
  // maintain borrow validity.
  TimeZoneFormatter._(this._underlying, bool isOwned, this._edge_self) {
    if (isOwned) {
      _finalizer.attach(this, _underlying.cast());
    }
  }

  static final _finalizer = ffi.NativeFinalizer(ffi.Native.addressOf(_ICU4XTimeZoneFormatter_destroy));

  /// Creates a new [`TimeZoneFormatter`] from locale data.
  ///
  /// Uses localized GMT as the fallback format.
  ///
  /// See the [Rust documentation for `try_new`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.try_new) for more information.
  ///
  /// Additional information: [1](https://docs.rs/icu/latest/icu/datetime/time_zone/enum.FallbackFormat.html)
  ///
  /// Throws [Error] on failure.
  factory TimeZoneFormatter.withLocalizedGmtFallback(DataProvider provider, Locale locale) {
    final result = _ICU4XTimeZoneFormatter_create_with_localized_gmt_fallback(provider._underlying, locale._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    return TimeZoneFormatter._(result.union.ok, true, []);
  }

  /// Creates a new [`TimeZoneFormatter`] from locale data.
  ///
  /// Uses ISO-8601 as the fallback format.
  ///
  /// See the [Rust documentation for `try_new`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.try_new) for more information.
  ///
  /// Additional information: [1](https://docs.rs/icu/latest/icu/datetime/time_zone/enum.FallbackFormat.html)
  ///
  /// Throws [Error] on failure.
  factory TimeZoneFormatter.withIso8601Fallback(DataProvider provider, Locale locale, IsoTimeZoneOptions options) {
    final temp = ffi2.Arena();
    final result = _ICU4XTimeZoneFormatter_create_with_iso_8601_fallback(provider._underlying, locale._underlying, options._pointer(temp));
    temp.releaseAll();
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    return TimeZoneFormatter._(result.union.ok, true, []);
  }

  /// Loads generic non-location long format. Example: "Pacific Time"
  ///
  /// See the [Rust documentation for `include_generic_non_location_long`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.include_generic_non_location_long) for more information.
  ///
  /// Throws [Error] on failure.
  void loadGenericNonLocationLong(DataProvider provider) {
    final result = _ICU4XTimeZoneFormatter_load_generic_non_location_long(_underlying, provider._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// Loads generic non-location short format. Example: "PT"
  ///
  /// See the [Rust documentation for `include_generic_non_location_short`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.include_generic_non_location_short) for more information.
  ///
  /// Throws [Error] on failure.
  void loadGenericNonLocationShort(DataProvider provider) {
    final result = _ICU4XTimeZoneFormatter_load_generic_non_location_short(_underlying, provider._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// Loads specific non-location long format. Example: "Pacific Standard Time"
  ///
  /// See the [Rust documentation for `include_specific_non_location_long`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.include_specific_non_location_long) for more information.
  ///
  /// Throws [Error] on failure.
  void loadSpecificNonLocationLong(DataProvider provider) {
    final result = _ICU4XTimeZoneFormatter_load_specific_non_location_long(_underlying, provider._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// Loads specific non-location short format. Example: "PST"
  ///
  /// See the [Rust documentation for `include_specific_non_location_short`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.include_specific_non_location_short) for more information.
  ///
  /// Throws [Error] on failure.
  void loadSpecificNonLocationShort(DataProvider provider) {
    final result = _ICU4XTimeZoneFormatter_load_specific_non_location_short(_underlying, provider._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// Loads generic location format. Example: "Los Angeles Time"
  ///
  /// See the [Rust documentation for `include_generic_location_format`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.include_generic_location_format) for more information.
  ///
  /// Throws [Error] on failure.
  void loadGenericLocationFormat(DataProvider provider) {
    final result = _ICU4XTimeZoneFormatter_load_generic_location_format(_underlying, provider._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// Loads localized GMT format. Example: "GMT-07:00"
  ///
  /// See the [Rust documentation for `include_localized_gmt_format`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.include_localized_gmt_format) for more information.
  ///
  /// Throws [Error] on failure.
  void includeLocalizedGmtFormat() {
    final result = _ICU4XTimeZoneFormatter_include_localized_gmt_format(_underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// Loads ISO-8601 format. Example: "-07:00"
  ///
  /// See the [Rust documentation for `include_iso_8601_format`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.include_iso_8601_format) for more information.
  ///
  /// Throws [Error] on failure.
  void loadIso8601Format(IsoTimeZoneOptions options) {
    final temp = ffi2.Arena();
    final result = _ICU4XTimeZoneFormatter_load_iso_8601_format(_underlying, options._pointer(temp));
    temp.releaseAll();
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    
  }

  /// Formats a [`CustomTimeZone`] to a string.
  ///
  /// See the [Rust documentation for `format`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.format) for more information.
  ///
  /// See the [Rust documentation for `format_to_string`](https://docs.rs/icu/latest/icu/datetime/time_zone/struct.TimeZoneFormatter.html#method.format_to_string) for more information.
  ///
  /// Throws [Error] on failure.
  String formatCustomTimeZone(CustomTimeZone value) {
    final writeable = _Writeable();
    final result = _ICU4XTimeZoneFormatter_format_custom_time_zone(_underlying, value._underlying, writeable._underlying);
    if (!result.isOk) {
      throw Error.values.firstWhere((v) => v._underlying == result.union.err);
    }
    return writeable.finalize();
  }
}

@meta.ResourceIdentifier()
@ffi.Native<ffi.Void Function(ffi.Pointer<ffi.Void>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_destroy')
// ignore: non_constant_identifier_names
external void _ICU4XTimeZoneFormatter_destroy(ffi.Pointer<ffi.Void> self);

@meta.ResourceIdentifier()
@ffi.Native<_ResultOpaqueInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_create_with_localized_gmt_fallback')
// ignore: non_constant_identifier_names
external _ResultOpaqueInt32 _ICU4XTimeZoneFormatter_create_with_localized_gmt_fallback(ffi.Pointer<ffi.Opaque> provider, ffi.Pointer<ffi.Opaque> locale);

@meta.ResourceIdentifier()
@ffi.Native<_ResultOpaqueInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>, _IsoTimeZoneOptionsFfi)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_create_with_iso_8601_fallback')
// ignore: non_constant_identifier_names
external _ResultOpaqueInt32 _ICU4XTimeZoneFormatter_create_with_iso_8601_fallback(ffi.Pointer<ffi.Opaque> provider, ffi.Pointer<ffi.Opaque> locale, _IsoTimeZoneOptionsFfi options);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_load_generic_non_location_long')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_load_generic_non_location_long(ffi.Pointer<ffi.Opaque> self, ffi.Pointer<ffi.Opaque> provider);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_load_generic_non_location_short')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_load_generic_non_location_short(ffi.Pointer<ffi.Opaque> self, ffi.Pointer<ffi.Opaque> provider);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_load_specific_non_location_long')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_load_specific_non_location_long(ffi.Pointer<ffi.Opaque> self, ffi.Pointer<ffi.Opaque> provider);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_load_specific_non_location_short')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_load_specific_non_location_short(ffi.Pointer<ffi.Opaque> self, ffi.Pointer<ffi.Opaque> provider);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_load_generic_location_format')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_load_generic_location_format(ffi.Pointer<ffi.Opaque> self, ffi.Pointer<ffi.Opaque> provider);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_include_localized_gmt_format')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_include_localized_gmt_format(ffi.Pointer<ffi.Opaque> self);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, _IsoTimeZoneOptionsFfi)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_load_iso_8601_format')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_load_iso_8601_format(ffi.Pointer<ffi.Opaque> self, _IsoTimeZoneOptionsFfi options);

@meta.ResourceIdentifier()
@ffi.Native<_ResultVoidInt32 Function(ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>, ffi.Pointer<ffi.Opaque>)>(isLeaf: true, symbol: 'ICU4XTimeZoneFormatter_format_custom_time_zone')
// ignore: non_constant_identifier_names
external _ResultVoidInt32 _ICU4XTimeZoneFormatter_format_custom_time_zone(ffi.Pointer<ffi.Opaque> self, ffi.Pointer<ffi.Opaque> value, ffi.Pointer<ffi.Opaque> writeable);
